/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.5a UL Standard
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Application TWI
Version : 
Date    : 05.01.2010
Author  :     
Company :      
Comments: 


Chip type               : ATxmega128A1
Program type            : Application
AVR Core Clock frequency: 14,745600MHz
Memory model            : Small
Data Stack size         : 2048
*****************************************************/

#include <io.h>
// Standard Input/Output functions
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <twi_master_driver.h>
#include <bcd.h>
#include <LCD_Font.h>
#include <string.h>
#include <delay.h>


//#include <PCF8583xmega.h>

// System Clocks initialization
void system_clocks_init(void)
{
unsigned char n,s;

// Optimize for speed
#pragma optsize- 
// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
#asm("cli")

// External 14745,600kHz oscillator initialization
OSC.XOSCCTRL=OSC_FRQRANGE_12TO16_gc | OSC_XOSCSEL_XTAL_16KCLK_gc;
// Enable the oscillator
OSC.CTRL|=OSC_XOSCEN_bm;

// System clock prescaler A division factor: 1
// System clock prescalers B & C division factors: B:1, C:1
// ClkPer4: 14745,600kHz
// ClkPer2: 14745,600kHz
// ClkPer:  14745,600kHz
// ClkCPU:  14745,600kHz
n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;
CCP=CCP_IOREG_gc;
CLK.PSCTRL=n;

// Wait for the external oscillator to stabilize
while ((OSC.STATUS & OSC_XOSCRDY_bm)==0);

// Select system clock source: External Osc. or Clock
n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_XOSC_gc;
CCP=CCP_IOREG_gc;
CLK.CTRL=n;

// Disable the unused oscillators: 2MHz, 32MHz, internal 32kHz, PLL
OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32MEN_bm | OSC_RC32KEN_bm | OSC_PLLEN_bm);

// Peripheral Clock output: Disabled
// Note: the correct Disabled direction for the Peripheral Clock output
// is configured in the ports_init function
PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;

// Restore interrupts enabled/disabled state
SREG=s;
// Restore optimization for size if needed
#pragma optsize_default
}

/* use the ATxmega128A1 SPID for the spi function */
#define _ATXMEGA_SPI_ SPID
#define _ATXMEGA_SPI_PORT_ PORTD 


/* use the SPI functions */
#include <spi.h>
//#include <spi_driver.h>

#define MAX_LINE	64      //Display
#define MAX_COLUMN	128
#define MAX_PAGE	(MAX_LINE/8)

// TWI
/*! Defining an example slave address. */
#define TWI_SLAVE_ADDRESS_RTC    0xA0
#define TWI_SLAVE_ADDRESS_EEP    0xA4
#define TWI_SLAVE_ADDRESS_DO2    0x70
#define TWI_SLAVE_ADDRESS_LM75   0x92
#define TWI_BAUDSETTING 0x45
/*! Defining number of bytes in buffer. */
#define NUM_BYTES        3

/* Global variables */
TWI_Master_t twiMaster;    /*!< TWI master module. */


// Displayinit
void displayinit(void);                             // Displayinitialisierung
void wrDatDisplay (unsigned char zeichen);          // Schreibt Daten zum Dispay
void wrComDisplay (unsigned char comando);          // Schreibt Comando zum Dispay
void cls(void);                                        // Clerar Screan beim Display
void LCD_SetColumnAddress(unsigned char Column);      // Setzt die Spaltenadresse
void LCD_SetPageAddress(unsigned char Page);          // Setzt die Zeilenadresse
void LCD_DisplayASCII(unsigned char XH_Dig, unsigned char adrPage, unsigned char adrColumn); //Schreibt ein ASCII Zeichen zum Display
unsigned char LCD_DisplayString(char *String, unsigned char adrPage, unsigned char adrColumn); // Schreibt ein String zum Display
void SPI_Write(unsigned char addr,unsigned char data); //       LED Display schreiben
unsigned char but_on(unsigned char tasterstatus);                   // Abfrage Button
unsigned char SPI_Read(unsigned char addr);                      // I/O erweiterung auslesen
void disbelan (void);                                   // Displaybeleuchtung an
void disbelaus (void);                                  // Displaybeleuchtung aus
unsigned char Bit_Set(unsigned char PORT, int Pin);     // Bit Setzte Fkt
unsigned char Bit_Reset(unsigned char PORT, int Pin);   // Bit Resetze Fkt
void rtc_init(unsigned char dated_alarm);
void rtc_write(unsigned char address,unsigned char data);
unsigned char rtc_read(TWI_Master_t *twi,unsigned char address);
void AusgabeWert (unsigned char zahl,unsigned char Page, unsigned char Col);
void rtc_start(void);
void rtc_stop(void);
unsigned char rtc_get_status(void);
void rtc_set_time(unsigned char hour,unsigned char min,unsigned char sec,unsigned char hsec);
void rtc_hold_off(void);
void rtc_hold_on(void);
void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec,unsigned char *hsec);
unsigned char rtc_read_bcd(unsigned char addr);
void rtc_write_bcd(unsigned char addr,unsigned char data);
void do_write(unsigned char data);
int WertTE(TWI_Master_t *twi);
void initLM75(TWI_Master_t *twi);
void ausgabeTemperatur(TWI_Master_t *twi,int temperatur);
void lesezeit (TWI_Master_t *twi);
char rtc_bcd_to_hex(char v);
unsigned char eep_write(unsigned char eepnr);
unsigned char eep_read(TWI_Master_t *twi);
unsigned char P1handl(unsigned char p1m);
void cycleroutine (unsigned char tc0zaehler);
void displayinitkl(void);



ISR(TWIE_TWIM_vect)			// Wichtig fr  TWI sonst hngt der Prozessor in der besagten While - Schleife
    {
      TWI_MasterInterruptHandler(&twiMaster);
    }   

// Watchdog Timer initialization
void watchdog_init(void)
{
unsigned char s,n;

// Optimize for speed
#pragma optsize- 
// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
#asm("cli")

// Watchdog Timer: On
// Watchdog timeout period: 8 s
n=(WDT.CTRL & (~WDT_PER_gm)) | WDT_PER_8KCLK_gc | WDT_ENABLE_bm | WDT_CEN_bm;
CCP=CCP_IOREG_gc;
WDT.CTRL=n;
// Watchdog window mode: Off
n=(WDT.WINCTRL & (~WDT_WEN_bm)) | WDT_WCEN_bm;
CCP=CCP_IOREG_gc;
WDT.WINCTRL=n;

// Restore interrupts enabled/disabled state
SREG=s;
// Restore optimization for size if needed
#pragma optsize_default
}

// Event System initialization
void event_system_init(void)
{
// Event System Channel 0 source: None
EVSYS.CH0MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 1 source: None
EVSYS.CH1MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 2 source: None
EVSYS.CH2MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 3 source: None
EVSYS.CH3MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 4 source: None
EVSYS.CH4MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 5 source: None
EVSYS.CH5MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 6 source: None
EVSYS.CH6MUX=EVSYS_CHMUX_OFF_gc;
// Event System Channel 7 source: None
EVSYS.CH7MUX=EVSYS_CHMUX_OFF_gc;

// Event System Channel 0 output: Disabled
// Note: the correct Disabled direction for the Event System Channel 0 output
// is configured in the ports_init function
PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_EVOUT_gm)) | PORTCFG_EVOUT_OFF_gc;
}

// Ports initialization
void ports_init(void)
{
// PORTA initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Input
// Bit7: Input
PORTA.DIR=0x00;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTA.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTA.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTA.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTA.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTA.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Sense both edges
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTA.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit6 Input/Sense configuration: Sense both edges
// Bit6 Output/Pull configuration: Totempole/No
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTA.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit7 Input/Sense configuration: Sense both edges
// Bit7 Output/Pull configuration: Totempole/No
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTA.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTA.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTA.INTCTRL=(PORTA.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTA.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTA.INT1MASK=0x00;

// PORTB initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Input
// Bit7: Input
PORTB.DIR=0x00;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTB.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTB.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTB.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTB.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTB.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Sense both edges
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTB.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit6 Input/Sense configuration: Sense both edges
// Bit6 Output/Pull configuration: Totempole/No
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTB.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit7 Input/Sense configuration: Sense both edges
// Bit7 Output/Pull configuration: Totempole/No
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTB.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTB.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTB.INTCTRL=(PORTB.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTB.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTB.INT1MASK=0x00;

// PORTC initialization
// Bit0: Input
// Bit1: Output
// Bit2: Output
// Bit3: Output
// Bit4: Output
// Bit5: Input
// Bit6: Output
// Bit7: Input
PORTC.DIR=0x5E;
// Bit0 Input/Sense configuration: Input buffer disabled
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTC.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Wired AND/Pull-up
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTC.PIN1CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Wired OR/Pull-up
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTC.PIN2CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Wired OR/Pull-up
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTC.PIN3CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Wired AND/Pull-up
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTC.PIN4CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit5 Input/Sense configuration: Sense low level
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTC.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_LEVEL_gc;
// Bit6 Input/Sense configuration: Input buffer disabled
// Bit6 Output/Pull configuration: Wired OR/Pull-up
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTC.PIN6CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit7 Input/Sense configuration: Sense both edges
// Bit7 Output/Pull configuration: Wired OR/Pull-down
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTC.PIN7CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTC.OUT=0x40;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTC.INTCTRL=(PORTC.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTC.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTC.INT1MASK=0x00;

// PORTD initialization
// Bit0: Output
// Bit1: Output
// Bit2: Output
// Bit3: Input
// Bit4: Output
// Bit5: Output
// Bit6: Input
// Bit7: Output
PORTD.DIR=0xB7;
// Bit0 Input/Sense configuration: Input buffer disabled
// Bit0 Output/Pull configuration: Wired AND/Pull-up
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTD.PIN0CTRL=PORT_OPC_PULLUP_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit1 Input/Sense configuration: Input buffer disabled
// Bit1 Output/Pull configuration: Wired AND/Pull-up
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTD.PIN1CTRL=PORT_OPC_PULLUP_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit2 Input/Sense configuration: Input buffer disabled
// Bit2 Output/Pull configuration: Wired OR/Pull-up
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTD.PIN2CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit3 Input/Sense configuration: Sense low level
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTD.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_LEVEL_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Wired AND/Pull-up
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTD.PIN4CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Input buffer disabled
// Bit5 Output/Pull configuration: Wired AND/Pull-up
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTD.PIN5CTRL=PORT_OPC_PULLUP_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit6 Input/Sense configuration: Sense both edges
// Bit6 Output/Pull configuration: Totempole/Pull-up (on input)
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTD.PIN6CTRL=PORT_OPC_PULLDOWN_gc | PORT_ISC_BOTHEDGES_gc;
// Bit7 Input/Sense configuration: Input buffer disabled
// Bit7 Output/Pull configuration: Wired AND/Pull-up
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTD.PIN7CTRL=PORT_OPC_PULLUP_gc | PORT_ISC_INPUT_DISABLE_gc;
// OUT register
PORTD.OUT=0x13;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTD.INTCTRL=(PORTD.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTD.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTD.INT1MASK=0x00;

// PORTE initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Input
// Bit7: Output
PORTE.DIR=0x80;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Wired AND/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTE.PIN0CTRL=PORT_OPC_WIREDAND_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Wired AND/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTE.PIN1CTRL=PORT_OPC_WIREDAND_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTE.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTE.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTE.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Sense both edges
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTE.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit6 Input/Sense configuration: Sense both edges
// Bit6 Output/Pull configuration: Totempole/No
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTE.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit7 Input/Sense configuration: Input buffer disabled
// Bit7 Output/Pull configuration: Wired AND/Pull-up
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTE.PIN7CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// OUT register
PORTE.OUT=0x03;
// Interrupt 0 level: Low
// Interrupt 1 level: Disabled
PORTE.INTCTRL=(PORTE.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_LO_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: On
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTE.INT0MASK=0x10;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTE.INT1MASK=0x00;

// PORTF initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Output
// Bit7: Output
PORTF.DIR=0xC0;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTF.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTF.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTF.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTF.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTF.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Sense both edges
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTF.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit6 Input/Sense configuration: Input buffer disabled
// Bit6 Output/Pull configuration: Wired OR/Pull-up
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTF.PIN6CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit7 Input/Sense configuration: Input buffer disabled
// Bit7 Output/Pull configuration: Wired OR/Pull-up
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTF.PIN7CTRL=PORT_OPC_WIREDORPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// OUT register
PORTF.OUT=0xC0;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTF.INTCTRL=(PORTF.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTF.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTF.INT1MASK=0x00;

// PORTH initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Input
// Bit7: Input
PORTH.DIR=0x00;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTH.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTH.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTH.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTH.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTH.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Sense both edges
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTH.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit6 Input/Sense configuration: Sense both edges
// Bit6 Output/Pull configuration: Totempole/No
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTH.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit7 Input/Sense configuration: Sense both edges
// Bit7 Output/Pull configuration: Totempole/No
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTH.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTH.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTH.INTCTRL=(PORTH.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTH.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTH.INT1MASK=0x00;

// PORTJ initialization
// Bit0: Output
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Input
// Bit7: Input
PORTJ.DIR=0x01;
// Bit0 Input/Sense configuration: Input buffer disabled
// Bit0 Output/Pull configuration: Wired AND/Pull-up
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTJ.PIN0CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_INPUT_DISABLE_gc;
// Bit1 Input/Sense configuration: Sense low level
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTJ.PIN1CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// Bit2 Input/Sense configuration: Sense low level
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTJ.PIN2CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// Bit3 Input/Sense configuration: Sense low level
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTJ.PIN3CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// Bit4 Input/Sense configuration: Sense low level
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTJ.PIN4CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// Bit5 Input/Sense configuration: Sense low level
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTJ.PIN5CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// Bit6 Input/Sense configuration: Sense low level
// Bit6 Output/Pull configuration: Totempole/No
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTJ.PIN6CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// Bit7 Input/Sense configuration: Sense low level
// Bit7 Output/Pull configuration: Totempole/No
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTJ.PIN7CTRL=PORT_OPC_WIREDANDPULL_gc | PORT_ISC_LEVEL_gc;
// OUT register
PORTJ.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTJ.INTCTRL=(PORTJ.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTJ.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTJ.INT1MASK=0x00;

// PORTK initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
// Bit4: Input
// Bit5: Input
// Bit6: Input
// Bit7: Input
PORTK.DIR=0x00;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTK.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTK.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTK.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTK.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit4 Input/Sense configuration: Sense both edges
// Bit4 Output/Pull configuration: Totempole/No
// Bit4 inverted: Off
// Bit4 slew rate limitation: Off
PORTK.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit5 Input/Sense configuration: Sense both edges
// Bit5 Output/Pull configuration: Totempole/No
// Bit5 inverted: Off
// Bit5 slew rate limitation: Off
PORTK.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit6 Input/Sense configuration: Sense both edges
// Bit6 Output/Pull configuration: Totempole/No
// Bit6 inverted: Off
// Bit6 slew rate limitation: Off
PORTK.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit7 Input/Sense configuration: Sense both edges
// Bit7 Output/Pull configuration: Totempole/No
// Bit7 inverted: Off
// Bit7 slew rate limitation: Off
PORTK.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTK.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTK.INTCTRL=(PORTK.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
// Bit4 pin change interrupt 0: Off
// Bit5 pin change interrupt 0: Off
// Bit6 pin change interrupt 0: Off
// Bit7 pin change interrupt 0: Off
PORTK.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
// Bit4 pin change interrupt 1: Off
// Bit5 pin change interrupt 1: Off
// Bit6 pin change interrupt 1: Off
// Bit7 pin change interrupt 1: Off
PORTK.INT1MASK=0x00;

// PORTQ initialization
// Bit0: Input
// Bit1: Input
// Bit2: Input
// Bit3: Input
PORTQ.DIR=0x00;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTQ.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTQ.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit2 Input/Sense configuration: Sense both edges
// Bit2 Output/Pull configuration: Totempole/No
// Bit2 inverted: Off
// Bit2 slew rate limitation: Off
PORTQ.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit3 Input/Sense configuration: Sense both edges
// Bit3 Output/Pull configuration: Totempole/No
// Bit3 inverted: Off
// Bit3 slew rate limitation: Off
PORTQ.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTQ.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTQ.INTCTRL=(PORTQ.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
// Bit2 pin change interrupt 0: Off
// Bit3 pin change interrupt 0: Off
PORTQ.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
// Bit2 pin change interrupt 1: Off
// Bit3 pin change interrupt 1: Off
PORTQ.INT1MASK=0x00;

// PORTR initialization
// Bit0: Input
// Bit1: Input
PORTR.DIR=0x00;
// Bit0 Input/Sense configuration: Sense both edges
// Bit0 Output/Pull configuration: Totempole/No
// Bit0 inverted: Off
// Bit0 slew rate limitation: Off
PORTR.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// Bit1 Input/Sense configuration: Sense both edges
// Bit1 Output/Pull configuration: Totempole/No
// Bit1 inverted: Off
// Bit1 slew rate limitation: Off
PORTR.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
// OUT register
PORTR.OUT=0x00;
// Interrupt 0 level: Disabled
// Interrupt 1 level: Disabled
PORTR.INTCTRL=(PORTR.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
// Bit0 pin change interrupt 0: Off
// Bit1 pin change interrupt 0: Off
PORTR.INT0MASK=0x00;
// Bit0 pin change interrupt 1: Off
// Bit1 pin change interrupt 1: Off
PORTR.INT1MASK=0x00;
}

// PORTE interrupt 0 service routine
interrupt [PORTE_INT0_vect] void porte_int0_isr(void)
{
// write your code here
//but_on();
}

// Virtual Ports initialization
void vports_init(void)
{
// PORTA mapped to VPORT0
// PORTB mapped to VPORT1
PORTCFG.VPCTRLA=PORTCFG_VP1MAP_PORTB_gc | PORTCFG_VP0MAP_PORTA_gc;
// PORTC mapped to VPORT2
// PORTD mapped to VPORT3
PORTCFG.VPCTRLB=PORTCFG_VP3MAP_PORTD_gc | PORTCFG_VP2MAP_PORTC_gc;
}

// Disable a Timer/Counter type 0
void tc0_disable(TC0_t *ptc)
{
// Timer/Counter off
ptc->CTRLA=(ptc->CTRLA & (~TC0_CLKSEL_gm)) | TC_CLKSEL_OFF_gc;
// Issue a reset command
ptc->CTRLFSET=TC_CMD_RESET_gc;
}

// Disable a Timer/Counter type 1
void tc1_disable(TC1_t *ptc)
{
// Timer/Counter off
ptc->CTRLA=(ptc->CTRLA & (~TC1_CLKSEL_gm)) | TC_CLKSEL_OFF_gc;
// Issue a reset command
ptc->CTRLFSET=TC_CMD_RESET_gc;
}

// Timer/Counter TCC1 initialization
void tcc1_init(void)
{
unsigned char s;

// Note: the correct PORTC direction for the Compare Channels outputs
// is configured in the ports_init function

// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
#asm("cli")

// Disable and reset the timer/counter just to be sure
tc1_disable(&TCC1);
// Clock source: Peripheral Clock/1024
TCC1.CTRLA=(TCC1.CTRLA & (~TC1_CLKSEL_gm)) | TC_CLKSEL_DIV1024_gc;
// Mode: Normal Operation, Overflow Int./Event on TOP
// Compare/Capture on channel A: Off
// Compare/Capture on channel B: Off
TCC1.CTRLB=(TCC1.CTRLB & (~(TC1_CCAEN_bm | TC1_CCBEN_bm | TC1_WGMODE_gm))) |
	TC_WGMODE_NORMAL_gc;

// Capture event source: Event Channel 0
// Capture event action: None
TCC1.CTRLD=(TCC1.CTRLD & (~(TC1_EVACT_gm | TC1_EVSEL_gm))) |
	TC_EVACT_OFF_gc | TC_EVSEL_CH0_gc;

// Overflow interrupt: Low Level
// Error interrupt: Disabled
TCC1.INTCTRLA=(TCC1.INTCTRLA & (~(TC1_ERRINTLVL_gm | TC1_OVFINTLVL_gm))) |
	TC_ERRINTLVL_OFF_gc | TC_OVFINTLVL_LO_gc;

// Compare/Capture channel A interrupt: Disabled
// Compare/Capture channel B interrupt: Disabled
TCC1.INTCTRLB=(TCC1.INTCTRLB & (~(TC1_CCBINTLVL_gm | TC1_CCAINTLVL_gm))) |
	TC_CCBINTLVL_OFF_gc | TC_CCAINTLVL_OFF_gc;

// High resolution extension: Off
HIRESC.CTRL&= ~HIRES_HREN1_bm;

// Clear the interrupt flags
TCC1.INTFLAGS=TCC1.INTFLAGS;
// Set counter register
TCC1.CNT=0x0000;
// Set period register
TCC1.PER=0x0000;
// Set channel A Compare/Capture register
TCC1.CCA=0x0000;
// Set channel B Compare/Capture register
TCC1.CCB=0x0000;

// Restore interrupts enabled/disabled state
SREG=s;
}



// Disable an USART
void usart_disable(USART_t *pu)
{
// Rx and Tx are off
pu->CTRLB=0;
// Ensure that all interrupts generated by the USART are off
pu->CTRLA=0;
}

// USARTE1 initialization
void usarte1_init(void)
{
// Note: the correct PORTE direction for the RxD, TxD and XCK signals
// is configured in the ports_init function

// Transmitter is enabled
// Set TxD=1
PORTE.OUTSET=0x80;

// Communication mode: Asynchronous USART
// Data bits: 8
// Stop bits: 1
// Parity: Disabled
USARTE1.CTRLC=USART_CMODE_ASYNCHRONOUS_gc | USART_PMODE_DISABLED_gc | USART_CHSIZE_8BIT_gc;

// Receive complete interrupt: Disabled
// Transmit complete interrupt: Disabled
// Data register empty interrupt: Disabled
USARTE1.CTRLA=(USARTE1.CTRLA & (~(USART_RXCINTLVL_gm | USART_TXCINTLVL_gm | USART_DREINTLVL_gm))) |
	USART_RXCINTLVL_OFF_gc | USART_TXCINTLVL_OFF_gc | USART_DREINTLVL_OFF_gc;

// Required Baud rate: 115200
// Real Baud Rate: 115200,0, Error: 0,0 %
USARTE1.BAUDCTRLA=0x80;
USARTE1.BAUDCTRLB=((0xF9 << USART_BSCALE_bp) & USART_BSCALE_gm) | 0x03;

// Receiver: On
// Transmitter: On
// Double transmission speed mode: Off
// Multi-processor communication mode: Off
USARTE1.CTRLB=(USARTE1.CTRLB & (~(USART_RXEN_bm | USART_TXEN_bm | USART_CLK2X_bm | USART_MPCM_bm | USART_TXB8_bm))) |
	USART_RXEN_bm | USART_TXEN_bm;
}

// MCP23S17 SPI Slave Device
#define SPI_SLAVE_ID    0x40
#define SPI_SLAVE_ADDR  0x00      // A2=0,A1=0,A0=0
#define SPI_SLAVE_WRITE 0x00
#define SPI_SLAVE_READ  0x01

// MCP23S17 Registers Definition for BANK=0 (default)
#define IODIRA 0x00
#define IODIRB 0x01
#define IOCONA 0x0A
#define GPPUA  0x0C
#define GPPUB  0x0D
#define GPIOA  0x12
#define GPIOB  0x13


// Receive a character from USARTE1
// USARTE1 is used as the default input device by the 'getchar' function
#define _ALTERNATE_GETCHAR_

#pragma used+
char getchar(void)
{
char data;
unsigned char status;

while (1)
      {
      while (((status=USARTE1.STATUS) & USART_RXCIF_bm) == 0);
      data=USARTE1.DATA;
      if ((status & (USART_FERR_bm | USART_PERR_bm | USART_BUFOVF_bm)) == 0) return data;
      }
}
#pragma used-

// Write a character to the USARTE1 Transmitter
// USARTE1 is used as the default output device by the 'putchar' function
#define _ALTERNATE_PUTCHAR_

#pragma used+
void putchar(char c)
{
while ((USARTE1.STATUS & USART_DREIF_bm) == 0);
USARTE1.DATA=c;
}
#pragma used-

void IOPORTJ(void);



// Declare your global variables here
bit PINJ1=0,PINJ2=0,PINJ3=0,PINJ4=0,PINJ5=0,PINJ6=0,PINJ7=0;
bit ok=0,up=0,down=0,esc=0,hp1=0,hp2=0;
unsigned char __rtc_status;
bit __rtc_alarm;
unsigned char h,m,s,hs;
unsigned int tc0intcounter=0;



void main(void)
{
// Declare your local variables here
unsigned char n;
uint8_t test;
unsigned char defIOA=0x00,defIOB=0x00;
unsigned char twiad=0x00;
uint8_t buffer[2];
bool zwischen;
int Temperatur=0;
char P1merker=0x00, P2merker=0x00;
unsigned char tast=0x00;
unsigned char tcseccount=0x00;


// Check the reset source
n=RST.STATUS;
if (n & RST_PORF_bm)
	{
	// Power on reset

	}
else if (n & RST_EXTRF_bm)
	{
	// External reset

	}
else if (n & RST_BORF_bm)
	{
	// Brown out reset

	}
else if (n & RST_WDRF_bm)
	{
	// Watchdog reset

	}
else if (n & RST_PDIRF_bm)
	{
	// Program and debug interface reset

	}
else if (n & RST_SRF_bm)
	{
	// Software reset

	}
else if (n & RST_SDRF_bm)
	{
	// Spike detection reset

	}
// Clear the reset flag
RST.STATUS=n;

// Interrupt system initialization
// Optimize for speed
#pragma optsize- 
// Make sure the interrupts are disabled
#asm("cli")
// Low level interrupt: On
// Round-robin scheduling for low level interrupt: Off
// Medium level interrupt: On
// High level interrupt: On
// The interrupt vectors will be placed at the start of the Application FLASH section
n=(PMIC.CTRL & (~(PMIC_RREN_bm | PMIC_IVSEL_bm | PMIC_HILVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm ))) |
	PMIC_LOLVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_HILVLEN_bm | TWIE_TWIM_vect;	// <= Gaaaanz wichtig den TWIE_TWIM_vect mu man hier von Hand ergnzen
CCP=CCP_IOREG_gc;
PMIC.CTRL=n;
// Set the default priority for round-robin scheduling
PMIC.INTPRI=0x00;
// Restore optimization for size if needed
#pragma optsize_default

// Watchdog timer initialization
watchdog_init();

// System clocks initialization
system_clocks_init();

// Event system initialization
event_system_init();

// Ports initialization
ports_init();

// SPI initialisation
SPID.CTRL =0x51; 
               

// Virtual Ports initialization
vports_init();

// Timer/Counter TCC0 is disabled
tc0_disable(&TCC0);

// Timer/Counter TCC1 initialization
tcc1_init();

// Timer/Counter TCD0 is disabled
tc0_disable(&TCD0);

// Timer/Counter TCD1 is disabled
tc1_disable(&TCD1);

// Timer/Counter TCE0 is disabled
tc0_disable(&TCE0);

// Timer/Counter TCE1 is disabled
tc1_disable(&TCE1);

// Timer/Counter TCF0 is disabled
tc0_disable(&TCF0);

// Timer/Counter TCF1 is disabled
tc1_disable(&TCF1);

// USARTC0 is disabled
usart_disable(&USARTC0);

// USARTC1 is disabled
usart_disable(&USARTC1);

// USARTD0 is disabled
usart_disable(&USARTD0);

// USARTD1 is disabled
usart_disable(&USARTD1);

// USARTE0 is disabled
usart_disable(&USARTE0);

// USARTE1 initialization
usarte1_init();

// USARTF0 is disabled
usart_disable(&USARTF0);

// USARTF1 is disabled
usart_disable(&USARTF1);

PORTD.OUT = 0x13; //CS I/O = hi; RESET Display = hi; RESET I/O = hi 
PORTF.OUT = Bit_Set(PORTF.OUT,7); //vorbergehend Display Reset hi
PORTF.OUT = Bit_Set(PORTF.OUT,6); //vorbergehend I/O Reset hi
PORTC.OUT = PIN6_bm; // CS Display = hi 
PORTD.OUT = Bit_Set(PORTD.OUT,0);
PORTD.OUT = Bit_Set(PORTD.OUT,1); 

// TWI Master Init
TWI_MasterInit(&twiMaster,&TWIE,TWI_MASTER_INTLVL_LO_gc,TWI_BAUDSETTING);//

delay_ms(10);
// SPI I/O Einrichten
SPI_Write(IOCONA,0x20);                 // I/O Control Register: BANK=0, SEQOP=1, HAEN=0 (DISable Addressing)
SPI_Write(IODIRA,0xF9);                 // GPIOA Register definieren
SPI_Write(IODIRB,0x1F);                 // GPIOB Register definieren
SPI_Write(GPPUA,0xF9);                  // Enable Pull-up Resistor on GPIOA
SPI_Write(GPPUB,0x1F);                  // Enable Pull-up Resistor on GPIOB
SPI_Write(GPIOA,0x00);                  // Reset Output on GPIOA
SPI_Write(GPIOB,0x00);                  // Reset Output on GPIOB

defIOA=SPI_Read(GPIOA);
defIOB=SPI_Read(GPIOB);
PORTD.OUT = Bit_Set(PORTD.OUT,0);
PORTD.OUT = Bit_Set(PORTD.OUT,1);



// Displayinit

if (PORTC.IN & 0x80)
        {
        displayinit();
        }
else
        {
        displayinitkl();
        }


// Globaly enable interrupts
#asm("sei")

disbelan();
cls();

initLM75(&twiMaster);
delay_ms(75);
rtc_init(0);
delay_ms(1);
rtc_write(00,80);
delay_ms(1);
rtc_set_time(00,00,00,00);
rtc_write(00,00);
delay_ms(1);
test=0x00;
while (1)       // ********************************************* H a u p t p r o g r a m m
      {
      // Place your code here 
      #asm("wdr") 
      tast=but_on(tast);
      //SPI_Write(GPIOA,0x04); 
      LCD_DisplayString("K1:", 0, 0);
      LCD_DisplayString("K2:", 0, 40);
      LCD_DisplayString("K3:", 0, 80);   
      if(hp1==1)
        {
        hp1=0;
        PORTC.OUT^= 1<<4;
        } 
      if ((PORTC.OUT & 0x10)!=0x10)
        {
        LCD_DisplayString("Aus", 0, 20);
        }
      else
        {
        LCD_DisplayString("Ein", 0, 20);
        }  
      if(hp2==1)
        {
        hp2=0;
        PORTC.OUT^= 1<<3;
        } 
      if ((PORTC.OUT & 0x08)!=0x08)
        {
        LCD_DisplayString("Aus", 0, 60);
        }
      else
        {
        LCD_DisplayString("Ein", 0, 60);
        }
      IOPORTJ();
      if(PINJ2==1)
        {
        PORTC.OUT=Bit_Set(PORTC.OUT,2);
        LCD_DisplayString("Ein", 0, 100); 
        
        }
      else
        {
        PORTC.OUT=Bit_Reset(PORTC.OUT,2);
        LCD_DisplayString("Aus", 0, 100);
        }      
      AusgabeWert (PORTC.IN,1, 0); 
      if (ok==1)
        {  
        eep_write(0);
        ok=0;
        } 
      /*AusgabeWert(s,4,1);
      LCD_DisplayString("Sekunden",4, 15);  */
      if(tc0intcounter>10000)
        { 
        SPI_Write(GPIOA,0x04); 
        cycleroutine (tcseccount);
        Temperatur=WertTE(&twiMaster);
        ausgabeTemperatur(&twiMaster,Temperatur);
        lesezeit (&twiMaster); 
        eep_read (&twiMaster);
        #asm("cli") 
        tc0intcounter=0;
        #asm("sei")
        AusgabeWert((tcseccount),2,0); 
        SPI_Write(GPIOA,0x00);
        tcseccount++;
        if (tcseccount>0x60) tcseccount=0;
        }   
      //AusgabeWert(rtc_get_status(),7,0);
      //test++;
      
      };
}


void IOPORTJ(void)
{
if (PORTJ.IN & 0x02)
        {
        PINJ1=0;
        }
else
        {
        PINJ1=1;
        }
if (PORTJ.IN & 0x04)
        {
        PINJ2=0;
        }
else
        {
        PINJ2=1;
        
        }
if (PORTJ.IN & 0x08)
        {
        PINJ3=0;
        }
else
        {
        PINJ3=1;
        } 
if (PORTJ.IN & 0x10)
        {
        PINJ4=0;
        }
else
        {
        PINJ4=1;
        } 
if (PORTJ.IN & 0x20)
        {
        PINJ5=0;
        }
else
        {
        PINJ5=1;
        } 
if (PORTJ.IN & 0x40)
        {
        PINJ6=0;
        }
else
        {
        PINJ6=1;
        }   
if (PORTJ.IN & 0x80)
        {
        PINJ7=0;
        }
else
        {
        PINJ7=1;
        }                                                
}


// LED schreiben
void SPI_Write(unsigned char addr,unsigned char data)
{
 unsigned char mcpzw=0;
  // Activate the CS pin
  PORTD.OUT = Bit_Reset(PORTD.OUT,4);
  delay_us(1);
  // Start MCP23S17 OpCode transmission 
 mcpzw = SPI_SLAVE_ID | ((SPI_SLAVE_ADDR << 1) & 0x0E)| SPI_SLAVE_WRITE;
  spi(mcpzw);
  // Start MCP23S17 Register Address transmission
  spi(addr);                      // Wait for transmission complete
  // Start Data transmission
  spi(data);  
  PORTD.OUT = Bit_Set(PORTD.OUT,4);
}

unsigned char SPI_Read(unsigned char addr)
{
 unsigned char mcpzw=0,rd_data=0;
  // Activate the CS pin
  PORTD.OUT = Bit_Reset(PORTD.OUT,4);
  delay_us(1);
  // Start MCP23S17 OpCode transmission 
 mcpzw = SPI_SLAVE_ID | ((SPI_SLAVE_ADDR << 1) & 0x0E)| SPI_SLAVE_READ;
  spi(mcpzw);
  // Start MCP23S17 Register Address transmission 
  delay_us(100);
  rd_data=spi(addr);                      // Wait for transmission complete
  delay_us(100);
  rd_data=spi(0x00);
  PORTD.OUT = Bit_Set(PORTD.OUT,4);
  return rd_data;
}

unsigned char but_on(unsigned char tasterstatus)
{
unsigned char IOA=0x00, IOB=0x00;
IOA=0xFF-SPI_Read(GPIOA);
if (IOA != tasterstatus)
{
//AusgabeWert(IOA,2,0);
if((IOA >>3)==1)
        {
        ok=1;
        }
else
        {
        //ok=0;
        } 
if((IOA >>0)==1)
        {
        up=1;
        }
else
        {
        //ok=0;
        } 
if((IOA >>4)==1)
        {
        down=1;
        }
else
        {
        //ok=0;
        }
if((IOA >>5)==1)
        {
        esc=1;
        }
else
        {
        //ok=0;
        }
if((IOA >>6)==1)
        {
        hp1=1;
        }
else
        {
        //ok=0;
        } 
if((IOA >>7)==1)
        {
        hp2=1;
        }
else
        {
        //ok=0;
        }                              
}
else{};

IOB=SPI_Read(GPIOB);
return IOA;
}

void disbelan (void)
{
unsigned char bel=0x00;
bel=SPI_Read(GPIOB);
bel=bel | 0xE0;
SPI_Write(GPIOB,bel);

}

void disbelaus (void)
{
unsigned char bel=0x00;
bel=SPI_Read(GPIOB);
bel=bel | 0xE0;
SPI_Write(GPIOB,bel^=0xE0);
}

unsigned char Bit_Set(unsigned char PORT, int Pin)
{
PORT=PORT |(1<<Pin);
return PORT;
}

unsigned char Bit_Reset(unsigned char PORT, int Pin)
{
PORT = PORT |(1<<Pin);
PORT ^= 1<<Pin;
return PORT; 
}




void AusgabeWert (unsigned char zahl,unsigned char Page, unsigned char Col)
{
unsigned char zwischen;
zwischen= zahl/0x10;
if (zwischen<0x0A)
        {
        LCD_DisplayASCII(zwischen+0x30,Page,Col);
        }
else
        {
        LCD_DisplayASCII(zwischen+0x37,Page,Col);
        }
zwischen= zahl%0x10;
if (zwischen<0x0A)
        {
        LCD_DisplayASCII(zwischen+0x30,Page,Col+5);
        }
else
        {
        LCD_DisplayASCII(zwischen+0x37,Page,Col+5);
        }

}


void rtc_write( unsigned char address,unsigned char data)
{
unsigned char sendbuffer[2];
sendbuffer[0]=address;
sendbuffer[1]=data;
TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_RTC,sendbuffer,2);
while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig 
        }

}

void rtc_init(unsigned char dated_alarm)
{
unsigned char d;
d=0x90;
if (dated_alarm) d=0xb0;
__rtc_status=0;
__rtc_alarm=0;
rtc_write(0,0);
rtc_write(4,rtc_read(&twiMaster,4)&0x3f);
rtc_write(8,d);
}

unsigned char rtc_read(TWI_Master_t *twi,unsigned char address)
{
unsigned char a;
unsigned char sendbuffer [1];
sendbuffer [0]=address;
a=0xa0;
TWI_MasterWrite(&twiMaster,a,sendbuffer,1);
while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig
        }
a|=1;
TWI_MasterWriteRead(&twiMaster,a,0,0,1);
while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig
        }
a= twi->readData[0x00];
return a;
} 

void rtc_set_time(unsigned char hour,unsigned char min,
unsigned char sec,unsigned char hsec)
{
rtc_stop();
rtc_write_bcd(1,hsec);
rtc_write_bcd(2,sec);
rtc_write_bcd(3,min);
rtc_write_bcd(4,hour);
rtc_start();
}      

void rtc_stop(void)
{
rtc_get_status();
__rtc_status|=0x80;
rtc_write(0,__rtc_status);
}

void rtc_start(void)
{
rtc_get_status();
__rtc_status&=0x7f;
rtc_write(0,__rtc_status);
}

unsigned char rtc_get_status(void)
{
__rtc_status=rtc_read(&twiMaster,0);
__rtc_alarm=(__rtc_status&2);
return __rtc_status;
}

void rtc_write_bcd(unsigned char addr,unsigned char data)
{
rtc_write(addr,bin2bcd(data));
}

void rtc_hold_off(void)
{
rtc_get_status();
__rtc_status&=0xbf;
rtc_write(0,__rtc_status);
}

void rtc_hold_on(void)
{
rtc_get_status();
__rtc_status|=0x40;
rtc_write(0,__rtc_status);
}

void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec,unsigned char *hsec)
{
rtc_hold_on();
*hsec=rtc_read_bcd(1);
*sec=rtc_read_bcd(2);
*min=rtc_read_bcd(3);
*hour=rtc_read_bcd(4);
rtc_hold_off();
}

unsigned char rtc_read_bcd(unsigned char addr)
{
unsigned char zwischen;
zwischen=rtc_read(&twiMaster,addr);
return bcd2bin(zwischen);
}

void do_write(unsigned char data)
{
unsigned char sendbuffer[1];
//sendbuffer[0]=TWI_SLAVE_ADDRESS_DO2;
sendbuffer[0]=data;
//sendbuffer[1]=data;
TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_DO2,sendbuffer,1);
while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig 
        }

}

void initLM75(TWI_Master_t *twi)
{
//int ergebnis;
//unsigned char cTest;
unsigned char sendbuffer[3];
char input1, input2; //bit1, bit2, temp1, , halbert 
	sendbuffer[0] = 0x01;              // Pointer auf "Configuration"
	sendbuffer[1] = 0x18;              // Fault Queue: 6 , OS Polarity: active low , Comperator mode , Shutdown inactive
        TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_LM75,sendbuffer,2);  
        while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig 
        }        
	sendbuffer[0] = 0x00;              // Register 0 = Temperatur  
        TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_LM75,sendbuffer,1);
         while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig 
        }
	delay_ms(75);
	TWI_MasterRead(&twiMaster,(TWI_SLAVE_ADDRESS_LM75|1),2);
         while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig 
        }
	input1 = twi->readData[0x01];  
	input2 = twi->readData[0x00]; 	
}       


int WertTE(TWI_Master_t *twi)
{   
int ergebnis,myCounter;;
char input1, input2, bit1, bit2, temp1;//, halbert
unsigned char sladr=(TWI_SLAVE_ADDRESS_LM75|1);

TWI_MasterRead(&twiMaster,sladr,2);
while (twiMaster.status !=TWIM_STATUS_READY)
        {// Warte bis Transaction Fertig 
        }
input2 = twi->readData[0x01];  
input1 = twi->readData[0x00]; 
bit1 = input1 & 0x80;           // Vorzeichen
bit1 >>= 7;  
temp1 = input1;
temp1 &= 0x7F;
                  // Temperaturwert
        
if (bit1 == 0x01)               // Invertieren
        {
        temp1 = ~temp1; 
        temp1 &= 0x7F;     
        temp1 += 0x01;
        };
        
bit2 = input2 & 0x80;           // Nachkommastelle
bit2 >>= 7;
        
ergebnis = (int) temp1;
ergebnis *= 10; 
        
if (bit2 == 0x01)               // Nachkommastelle
        {
        ergebnis += 5;        
        };
if (bit1 == 0x01)               // Invertieren
        {
        ergebnis *= -1;
        };
return ergebnis;
}

void ausgabeTemperatur(TWI_Master_t *twi,int temperatur)
{
int zwischen=0;
unsigned char col=0;
if (temperatur<0)
        {
        temperatur = temperatur * (-1);
        LCD_DisplayASCII(0x2D,5,col);
        col+=5;
        }
else{}

if (temperatur>100)
        {
        zwischen=temperatur/100;
        LCD_DisplayASCII(zwischen+0x30,5,col);
        col+=5;
        }
else
        {
        LCD_DisplayASCII(0x30,5,col);
        col+=5;
        }
temperatur=temperatur%100;
if (temperatur>10)
        {
        zwischen=temperatur/10;
        LCD_DisplayASCII(zwischen+0x30,5,col);
        col+=5;
        }
else
        {
        LCD_DisplayASCII(0x30,5,col);
        col+=5;
        }
zwischen=temperatur%10;
LCD_DisplayASCII(0x2E,5,col);
col+=4;
LCD_DisplayASCII(zwischen+0x30,5,col);
col+=5;
LCD_DisplayASCII(0x81,5,col);
col+=5;
LCD_DisplayString("C",5, col);
LCD_DisplayString("Temperatur",5, 50);
}


void lesezeit (TWI_Master_t *twi)
{ 
unsigned char hh,hl,mh,ml,sh,sl;
unsigned char col=0;
unsigned char start_adresse[1];
        delay_ms(8);


start_adresse[0]=2;
//rtc_hold_on();
// Leseadresse nach RTC schreiben
		
TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_RTC,start_adresse,1);
while (twiMaster.status != TWIM_STATUS_READY) 
        {
        /* Wait until transaction is complete. */
	}

// Datum,Uhrzeit aus RTC 
TWI_MasterWriteRead(&twiMaster,(TWI_SLAVE_ADDRESS_RTC|1),0,0,3); //TWI_MasterWriteRead hier read! 
		                    
		while (twiMaster.status != TWIM_STATUS_READY) {
			/* Wait until transaction is complete. */
		}  
		//  RTC DS1338 -> TWI-Daten nach struct rtc_buf
		
		s   = rtc_bcd_to_hex(twi->readData[0x00]); 	//sek
		m   = rtc_bcd_to_hex(twi->readData[0x01]); 	//minute
		h   = rtc_bcd_to_hex(twi->readData[0x02]); 	//stunde 
/*		rtc_buf.w_tag    = rtc_bcd_to_hex(twi->readData[0x03]); 	//tag in der Woche
		rtc_buf.tag      = rtc_bcd_to_hex(twi->readData[0x04]); 	//tag
		rtc_buf.monat    = rtc_bcd_to_hex(twi->readData[0x05]); 	//monat
		rtc_buf.jahr     = rtc_bcd_to_hex(twi->readData[0x06]); 	//jahr   */
	delay_ms(5);
        //rtc_hold_off();
	hh = h;
	hl = h; 
        hh /= 0x0a;
        hl = hl - (hh * 0x0a) ; 
	mh = m;
	ml = m;
        mh /= 0x0a;
	ml = ml - (mh * 0x0a) ;
	sh = s;
	sl = s;
	sh /= 0x0a;
	sl = sl - (sh * 0x0a) ; 
        LCD_DisplayASCII(hh+0x30,6,col);
        col+=5;
        LCD_DisplayASCII(hl+0x30,6,col);
	col+=5;
	LCD_DisplayASCII(0x3A,6,col);
	col+=5;
	LCD_DisplayASCII(mh+0x30,6,col);
        col+=5;
        LCD_DisplayASCII(ml+0x30,6,col);
	col+=5;
	LCD_DisplayASCII(0x3A,6,col);
	col+=5;
	LCD_DisplayASCII(sh+0x30,6,col);
        col+=5;
        LCD_DisplayASCII(sl+0x30,6,col);
	col+=5;  
        LCD_DisplayString("Zeit",6, 50);

} 

//-------------------------------------BCD/HEX Berechnungen---------------------

char rtc_bcd_to_hex(char v)// rtc_bcd_to_hex: wandelt BCD zu HEX Zahl um 
{
  char n;

  n=v; 
  n=n & 0xF0;
  n=n/16;
  v =v & 0x0F;
  n=n*10+v;
  return(n);
}

unsigned char eep_write(unsigned char eepnr)
{
unsigned char h_address,l_address;
unsigned char wr_buffer[6];
h_address=0x00;
l_address=0x00;
wr_buffer[0]=h_address;
wr_buffer[1]=l_address;
wr_buffer[2]=eepnr;
wr_buffer[3]=s;
wr_buffer[4]=m;
wr_buffer[5]=h;
TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_EEP,wr_buffer,6);
while (twiMaster.status != TWIM_STATUS_READY) 
        {
        /* Wait until transaction is complete. */
	}
}

unsigned char eep_read(TWI_Master_t *twi)
{
unsigned char h_address,l_address,ehh,ehl,emh,eml,esl,esh,col;
unsigned char eh,em,es,enr;
unsigned char ad_buffer[2];
col=0;
h_address=0x00;
l_address=0x00;
ad_buffer[0]=h_address;
ad_buffer[1]=l_address;

TWI_MasterWrite(&twiMaster,TWI_SLAVE_ADDRESS_EEP,ad_buffer,2);
while (twiMaster.status != TWIM_STATUS_READY) 
        {
        /* Wait until transaction is complete. */
	} 

TWI_MasterWriteRead(&twiMaster,(TWI_SLAVE_ADDRESS_EEP|1),0,0,4); //TWI_MasterWriteRead hier read! 
		                    

		while (twiMaster.status != TWIM_STATUS_READY) {
			/* Wait until transaction is complete. */
		}
        
        enr=twi->readData[0x00];
        es=twi->readData[0x01];
        em=twi->readData[0x02];
        eh=twi->readData[0x03];
        
	ehh = eh;
	ehl = eh; 
        ehh /= 0x0a;
        ehl = ehl - (ehh * 0x0a) ; 
	emh = em;
	eml = em;
        emh /= 0x0a;
	eml = eml - (emh * 0x0a) ;
	esh = es;
	esl = es;
	esh /= 0x0a;
	esl = esl - (esh * 0x0a) ; 
        LCD_DisplayASCII(ehh+0x30,7,col);
        col+=5;
        LCD_DisplayASCII(ehl+0x30,7,col);
	col+=5;
	LCD_DisplayASCII(0x3A,7,col);
	col+=5;
	LCD_DisplayASCII(emh+0x30,7,col);
        col+=5;
        LCD_DisplayASCII(eml+0x30,7,col);
	col+=5;
	LCD_DisplayASCII(0x3A,7,col);
	col+=5;
	LCD_DisplayASCII(esh+0x30,7,col);
        col+=5;
        LCD_DisplayASCII(esl+0x30,7,col);
	col+=5;
        LCD_DisplayString("EEPROM",7,50); 
        
               
}
 
unsigned char P1handl(unsigned char p1m)
{
if (hp1==1)
        {
        p1m++;
        if ((p1m>>2)==1)
                {
                p1m=Bit_Reset(p1m,2); 
                p1m++;
                }
        else{}
        }     
 switch (p1m) 
 {
    case 0x01:
        {     
        LCD_DisplayString("0 Aus",0, 40);
        PORTC.OUT=Bit_Reset(PORTC.OUT,1);
        break;
        };
    case 0x02:
        {     
        p1m=0x42;
        break;
        };
    case 0x03:
        {     
        LCD_DisplayString("A Aus",0, 40);
        PORTC.OUT=Bit_Reset(PORTC.OUT,1);
        break;
        };
    case 0x41:
        {     
        p1m=0x01;
        break;
        };
    case 0x42:
        {     
        LCD_DisplayString("H Ein",0, 40);
        PORTC.OUT=Bit_Set(PORTC.OUT,1);
        break;
        };
    case 0x43:
        {     
        LCD_DisplayString("A Ein",0, 40);
        PORTC.OUT=Bit_Set(PORTC.OUT,1);
        break;
        };
    default:
        {
        p1m=0x03;
        }  
 } 
 return p1m;
 }               
 
 

void wrDatDisplay (unsigned char zeichen)
{
PORTC.OUT = Bit_Reset(PORTC.OUT,6);  // CS Low
delay_us(1);
spi(zeichen);
PORTC.OUT = Bit_Set(PORTC.OUT,6);  // CS Hi
}


void wrComDisplay (unsigned char comando)
{
PORTC.OUT = Bit_Reset(PORTC.OUT,6);   // CS Low
delay_us(1);
PORTD.OUT = Bit_Reset(PORTD.OUT,2);  // A0 Low
delay_us(1);
spi(comando);
PORTD.OUT = Bit_Set(PORTD.OUT,2);  // A0 Hi
delay_us(1);
PORTC.OUT = Bit_Set(PORTC.OUT,6);   // CS Hi
}

void displayinit(void)
{
PORTC.OUT = Bit_Reset(PORTC.OUT,6);  // CS Low
delay_us(1);
wrComDisplay (0x40);
delay_us(1);
wrComDisplay (0xA1);
delay_us(1);
wrComDisplay (0xC0);
delay_us(1);
wrComDisplay (0xA6);
delay_us(1);
wrComDisplay (0xA2);
delay_us(1);
wrComDisplay (0x2F);
delay_us(1);
wrComDisplay (0xF8);
delay_us(1);
wrComDisplay (0x00);
delay_us(1);
wrComDisplay (0x27);
delay_us(1);
wrComDisplay (0x81);
delay_us(1);
wrComDisplay (0x16);
delay_us(1);
wrComDisplay (0xAC);
delay_us(1);
wrComDisplay (0x00);
delay_us(1);
wrComDisplay (0xAF);
delay_us(1);
wrComDisplay (0xA4);
PORTC.OUT = Bit_Set(PORTC.OUT,6);   // CS Hi
//delay_ms(1500);
}

void LCD_SetColumnAddress(unsigned char Column)
{
	wrComDisplay(0x10 | (Column>>4));
	wrComDisplay(Column & 0x0F);
}

void LCD_SetPageAddress(unsigned char Page)
{
	Page &= 0x0F;
	wrComDisplay(0xB0 | Page);
}

void cls(void)
{
unsigned char lfva;
int lfvb=0;
wrComDisplay(0x40);
for(lfva=0;lfva<9;lfva++)      
        {
        LCD_SetColumnAddress(0);
        for(lfvb=0;lfvb<132;lfvb++)
                {
                wrDatDisplay(0x00);
                }
        wrComDisplay(0xB0+lfva);   
        } 
delay_us(1);
LCD_SetColumnAddress(0);        
wrComDisplay(0x40); 
wrComDisplay(0xB0);       
}



void LCD_DisplayASCII(unsigned char XH_Dig, unsigned char adrPage, unsigned char adrColumn)
{
unsigned char *dptr;               // dptr_adderss for Dig code.
unsigned char i;

if(XH_Dig < 0x20) XH_Dig = 0x20;
	        
dptr = &ASCII[(XH_Dig-0x20)*5];
	
LCD_SetPageAddress(adrPage);
LCD_SetColumnAddress(adrColumn);
for(i=0; i< 5; i++)
        {
    	wrDatDisplay(*dptr);
    	dptr = dptr + 1;
	}
} 

unsigned char LCD_DisplayString(char *String, unsigned char adrPage, unsigned char adrColumn)
{
    char cData[2];
    unsigned char uLen,uPage,uCol;
	
    uLen = strlen(String);
    uPage = adrPage;
    uCol = adrColumn;

    while(uLen)
    {
        cData[0] = *String++;
		if(cData[0] <= 0x80)
		{
			LCD_DisplayASCII(cData[0], uPage, uCol);
			uCol += 6;
			uLen --;
		}
		else
		{
		/*	cData[1] = *String++;
			LCD_DisplayHZ(cData,  uPage, uCol);
			uCol += 16;
			uLen -= 2;        */
		}
		
		if(uCol >= MAX_COLUMN)
		{
			uCol = 0;
			uPage += 2;
			if(uPage >= MAX_PAGE)
				uPage = 0;
		}
	}
	
    return uLen;
}


// Timer/counter TCC1 Overflow/Underflow interrupt service routine
interrupt [TCC1_OVF_vect] void tcc1_overflow_isr(void)
{
tc0intcounter++;
}

void cycleroutine (unsigned char tc0zaehler)
{
switch (tc0zaehler) 
        {
        case 0x45:
                {
                PORTF.OUT=Bit_Reset(PORTF.OUT,7);
                PORTD.OUT=Bit_Reset(PORTD.OUT,1);
                SPI_Write(GPIOA,0x02);
                delay_us(1);
                PORTD.OUT=Bit_Set(PORTD.OUT,1);
                PORTF.OUT=Bit_Set(PORTF.OUT,7);
                delay_us(1);
                if (PORTC.IN & 0x80)
                        {
                        displayinit();
                        }
                else
                        {
                        displayinitkl();
                        }
                break;
                }
    
    }; 

}

void displayinitkl(void)                
{
wrComDisplay (0x40);
delay_us(1);
wrComDisplay (0xA1);
delay_us(1);
wrComDisplay (0xC0);
delay_us(1);
wrComDisplay (0xA6);
delay_us(1);
wrComDisplay (0xA2);
delay_us(1);
wrComDisplay (0x2F);
delay_us(1);
wrComDisplay (0xF8);
delay_us(1);
wrComDisplay (0x00);
delay_us(1);
wrComDisplay (0x23);
delay_us(1);
wrComDisplay (0x81);
delay_us(1);
wrComDisplay (0x1F);
delay_us(1);
wrComDisplay (0xAC);
delay_us(1);
wrComDisplay (0x00);
delay_us(1);
wrComDisplay (0xAF);
}